variables:
  NPM_TOKEN: ${GITLAB_TOKEN}
  GITLAB_PROJECT_ID: ${CI_PROJECT_ID}
  CODE_QUALITY_DISABLED: "false"

include:
- project: beepbeepgo/public/gitlab-ci
  ref: main
  file: /templates/node/nodejs-default.gitlab-ci.yml

stages:
  - dependencies
  - test
  - deploy
  - pre-release
  - release

.vercel:
  image: node:14-alpine

  variables:
    PREVIEW_URL: ${CI_ENVIRONMENT_NAME}.vercel.beepbeepgo.io
    VERCEL_ORG_ID: $VERCEL_ORG_ID
    VERCEL_PROJECT_ID: $VERCEL_PROJECT_ID

  environment:
    name: vercel/$CI_COMMIT_REF_NAME
    url: https://$PREVIEW_URL

  before_script:
    - npm i -g vercel

  script:
    - DEPLOYMENT_URL=$(VERCEL_ORG_ID=$VERCEL_ORG_ID VERCEL_PROJECT_ID=$VERCEL_PROJECT_ID vercel --confirm -t $VERCEL_TOKEN --scope $VERCEL_USER)
    - vercel alias set $DEPLOYMENT_URL $PREVIEW_URL -t $VERCEL_TOKEN --scope $VERCEL_USER

vercel-dev:
  stage: deploy
  environment:
    name: dev
  extends: .vercel
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: never
    - if: $CI_COMMIT_BRANCH

vercel-qa:
  stage: deploy
  environment:
    name: qa
  extends: .vercel
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

vercel-prod:
  stage: deploy
  environment:
    name: prod
  extends: .vercel
  script:
    - vercel --prod -t $VERCEL_TOKEN --scope $VERCEL_USER
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: manual

